Crystal::SyntaxHighlighter::HTML - Crystal 1.20.3

# class Crystal::SyntaxHighlighter::HTML

- Crystal::SyntaxHighlighter::HTML
- Crystal::SyntaxHighlighter
- Reference
- Object

##
Overview

A syntax highlighter that renders Crystal source code with HTML markup.

NOTE To use `Crystal::SyntaxHighlighter::HTML`, you must explicitly import it with `require "crystal/syntax_highlighter/html"`

    require "crystal/syntax_highlighter/html"

    code = %(foo = bar("baz\#{PI + 1}") # comment)
    html = Crystal::SyntaxHighlighter::HTML.highlight(code)
    html # => "foo <span class=\"o\">=</span> bar(<span class=\"s\">&quot;baz</span><span class=\"i\">\#{</span><span class=\"t\">PI</span> <span class=\"o\">+</span> <span class=\"n\">1</span><span class=\"i\">}</span><span class=\"s\">&quot;</span>) <span class=\"c\"># comment</span>"

##
Defined in:

crystal/syntax_highlighter/html.cr

##
Constructors

- .new(io : IO)

  Creates a new instance of an HTML syntax highlighter.

##
Class Method Summary

- .highlight(io : IO, code : String)

  Highlights code and writes the result to io.

- .highlight(code : String)

  Highlights code and returns the result.

- .highlight!(code : String)

  Highlights code or returns unhighlighted code on error.

##
Instance Method Summary

- #render(type : TokenType, value : String)

  Renders token with text value.

- #render_delimiter(&)

  Renders a delimiter sequence.

- #render_interpolation(&)

  Renders an interpolation sequence.

- #render_string_array(&)

  Renders a string array sequence.

### Instance methods inherited from class `Crystal::SyntaxHighlighter`

highlight(code : String) highlight, render(type : TokenType, value : String) render, render_delimiter(&) render_delimiter, render_interpolation(&) render_interpolation, render_string_array(&) render_string_array

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, initialize initialize, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference) : Bool
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new, unsafe_construct(address : Pointer, *args, **opts) : self unsafe_construct

### Class methods inherited from class `Reference`

pre_initialize(address : Pointer) pre_initialize

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io : String | IO, root : String)
from_json(string_or_io : String | IO) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Constructor Detail

def self.new(io : IO) #

Creates a new instance of an HTML syntax highlighter.

Appends highlighted output (when calling `#highlight`) to io.

##
Class Method Detail

def self.highlight(io : IO, code : String) #

Highlights code and writes the result to io.

def self.highlight(code : String) #

Highlights code and returns the result.

def self.highlight!(code : String) #

Highlights code or returns unhighlighted code on error.

Same as `.highlight(code : String)` except that any error is rescued and returns unhighlighted source code.

##
Instance Method Detail

def render(type : TokenType, value : String) #
Description copied from class Crystal::SyntaxHighlighter

Renders token with text value.

def render_delimiter(&) #
Description copied from class Crystal::SyntaxHighlighter

Renders a delimiter sequence.

def render_interpolation(&) #
Description copied from class Crystal::SyntaxHighlighter

Renders an interpolation sequence.

def render_string_array(&) #
Description copied from class Crystal::SyntaxHighlighter

Renders a string array sequence.